package cn.timer.api.bean.jxgl;

import java.util.Date;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import cn.timer.api.config.exception.ValidationMsg;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author Tang 2020-05-26
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("考核评定")
public class JxglAppraisalAssessment extends Model<JxglAppraisalAssessment> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号 编号", example = "10")
	private Integer id;

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "考核id 考核id", example = "10")
	private Integer appraisalId;

	@ApiModelProperty(value = "评定人id 评定人id", example = "10")
	private Integer assessorId;

	@ApiModelProperty(value = "评定人名称", example = "评定人名称")
	private String assessorName;

	@NotBlank(message = ValidationMsg.NOTBLANK)
	@ApiModelProperty(value = "综合评分", example = "综合评分")
	private String comprehensiveScore;

	@ApiModelProperty(value = "评语", example = "评语")
	private String remarks;

	@ApiModelProperty(value = "类型 0自评 1上级评价", example = "10")
	private Integer type;
	
	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value = "创建时间", example = "2020-10-10 10:10:10")
	private Date createTime;

	@NotBlank(message = ValidationMsg.NOTBLANK)
	@ApiModelProperty(value = "等级", example = "等级")
	private String level;

}