package cn.timer.api.bean.jxgl;

import java.util.Date;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.Valid;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import cn.timer.api.config.validation.ValidList;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
* @author Tang 2020-05-26
*/

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("基础设置")
public class JxglBasicSetting extends Model<JxglBasicSetting> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue
    @TableId (type = IdType.AUTO)
	@ApiModelProperty(value="编号 编号",example="101")
    private Integer id;
    
	@ApiModelProperty(value="企业id 企业id",example="101")
    private Integer orgCode;
    
	@ApiModelProperty(value="最高分 最高分",example="101")
    private Integer maxScore;
    
	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value="创建时间 ",example="2020-10-10 10:10:10")
    private Date createTime;
    
	@TableField(fill = FieldFill.UPDATE)
	@ApiModelProperty(value="更新时间 ",example="2020-10-10 10:10:10")
    private Date updateTime;
    
	@Valid
	@TableField(exist = false) // 是否转换
	@ApiModelProperty(value="绩效等级",example="1")
	private ValidList<JxglPerformanceRating> performanceRatings;

}