package cn.timer.api.bean.jxgl;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author Tang 2020-05-26
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("绩效等级")
public class JxglPerformanceRating extends Model<JxglPerformanceRating> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号", example = "10")
	private Integer id;

	@ApiModelProperty(value = "绩效基础设置id", example = "10")
	private Integer basicSettingId;

	@NotBlank(message = "等级名称 不能为空")
	@ApiModelProperty(value = "等级名称", example = "等级名称")
	private String name;

	@NotNull(message = "区间最小分数 不能为空")
	@ApiModelProperty(value = "区间最小分数", example = "10")
	private Integer sectionMinScore;

	@NotNull(message = "区间最大分数 不能为空")
	@ApiModelProperty(value = "区间最大分数", example = "10")
	private Integer sectionMaxScore;

	@NotNull(message = "排序 不能为空")
	@ApiModelProperty(value = "排序", example = "10")
	private Integer ranks;

}