package cn.timer.api.dto.jxgl;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

import cn.timer.api.config.exception.ValidationMsg;
import cn.timer.api.utils.Page;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class AppraisalQuery extends Page{

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "绩效考核id", example = "")
	private Integer id;
	
	@ApiModelProperty(value = "企业id", example = "")
	private Integer orgCode;
	
	@ApiModelProperty(value = "姓名、手机号", example = "")
	private String query;
	
	@Max(value = 4,message = ValidationMsg.MAX+" 只能为 0目标填写 1目标确认 2自评 3上级评分 4 结果确认 5考核完成 6终止考核 7绩效归档")
	@Min(value = 0,message = ValidationMsg.MIN+" 只能为 0目标填写 1目标确认 2自评 3上级评分 4 结果确认 5考核完成 6终止考核 7绩效归档")
	@ApiModelProperty(value = "状态 0目标填写 1目标确认 2自评 3上级评分 4 结果确认 5考核完成 6终止考核 7绩效归档", example = "0")
	private Integer sts;
	
	@ApiModelProperty(value = "部门id", example = "")
	private Integer bmId;
	
}
